# frozen_string_literal: true

# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!

require "gapic/common"
require "gapic/config"
require "gapic/config/method"

require "google/cloud/data_catalog/v1/version"

require "google/cloud/data_catalog/v1/policy_tag_manager_serialization/credentials"
require "google/cloud/data_catalog/v1/policy_tag_manager_serialization/paths"
require "google/cloud/data_catalog/v1/policy_tag_manager_serialization/client"

module Google
  module Cloud
    module DataCatalog
      module V1
        ##
        # Policy Tag Manager serialization API service allows clients to manipulate
        # their policy tags and taxonomies in serialized format, where taxonomy is a
        # hierarchical group of policy tags.
        #
        # To load this service and instantiate a client:
        #
        #     require "google/cloud/data_catalog/v1/policy_tag_manager_serialization"
        #     client = ::Google::Cloud::DataCatalog::V1::PolicyTagManagerSerialization::Client.new
        #
        module PolicyTagManagerSerialization
        end
      end
    end
  end
end

helper_path = ::File.join __dir__, "policy_tag_manager_serialization", "helpers.rb"
require "google/cloud/data_catalog/v1/policy_tag_manager_serialization/helpers" if ::File.file? helper_path
